1. 程式人生 > >【Leetcode】Combination Sum IV

【Leetcode】Combination Sum IV

題目連結:

題目:

Given an integer array with all positive numbers and no duplicates, find the number of possible combinations that add up to a positive integer target.

Example:

nums = [1, 2, 3]
target = 4

The possible combination ways are:
(1, 1, 1, 1)
(1, 1, 2)
(1, 2, 1)
(1, 3)
(2, 1, 1)
(2, 2)
(3, 1)

Note that different sequences are counted as different combinations.

Therefore the output is 7
.

Follow up:
What if negative numbers are allowed in the given array?
How does it change the problem?
What limitation we need to add to the question to allow negative numbers?

思路:

dp,dp[i]表示當target為i 時,有多少種組合。 

狀態轉移方程:dp[i]=Σdp[i-nums[k]]  0<=k<=nums.length 

當然,需要考慮當i-nums[k]為0時,表示陣列中有target,則此時dp[i]為1,

時間複雜度O(n^2)

演算法:

	public int combinationSum4(int[] nums, int target) {
		int dp[] = new int[target + 1];
		for (int i = 0; i <= target; i++) {
			for (int k = 0; k < nums.length; k++) {
				if (i - nums[k] > 0) {
					dp[i] += dp[i - nums[k]];
				} else if (i - nums[k] == 0) {
					dp[i] += 1;
				}

			}
		}
		return dp[target];
	}